import 'package:plugin_platform_interface/plugin_platform_interface.dart';

import 'mirrorfly_uikit_plugin_method_channel.dart';

abstract class MirrorflyUikitPluginPlatform extends PlatformInterface {
  /// Constructs a MirrorflyUikitPluginPlatform.
  MirrorflyUikitPluginPlatform() : super(token: _token);

  static final Object _token = Object();

  static MirrorflyUikitPluginPlatform _instance = MethodChannelMirrorflyUikitPlugin();

  /// The default instance of [MirrorflyUikitPluginPlatform] to use.
  ///
  /// Defaults to [MethodChannelMirrorflyUikitPlugin].
  static MirrorflyUikitPluginPlatform get instance => _instance;

  /// Platform-specific implementations should set this with their own
  /// platform-specific class that extends [MirrorflyUikitPluginPlatform] when
  /// they register themselves.
  static set instance(MirrorflyUikitPluginPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  Future<String?> getPlatformVersion() {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }
}
